﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinTree;

namespace _135199
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add("Table1");

            dt.Columns.Add("SeriesCde", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Name", typeof(string)).Expression = "'Text'+[SeriesCde]";
            dt.Columns.Add("Activelnd", typeof(string)).DefaultValue  = "1";

            dt.Rows.Clear();
            DataRow row0 = dt.Rows.Add();
            //dt.Rows.Add("0", " ", "1");
            dt.Rows.Add("1", " ", "1");
            dt.Rows.Add("2", " ", "1");
            dt.Rows.Add("3", " ", "0");
            
            

            DataTable dt1 = ds.Tables.Add("Table2");

            dt1.Columns.Add("EpisodeCde", typeof(int)).AutoIncrement = true; 
            dt1.Columns.Add("Name", typeof(string)).Expression = "'Text'+[EpisodeCde]";
            dt1.Columns.Add("SeriesCde", typeof(int)).DefaultValue = "1";

            dt1.Rows.Clear();
            DataRow row2 = dt1.Rows.Add();
            //dt1.Rows.Add("0", " ", "1");
            dt1.Rows.Add("1", " ", "1");
            dt1.Rows.Add("2", " ", "1");
            dt1.Rows.Add("3", " ", "0");
            

            DataTable dt2 = ds.Tables.Add("Table3");

            dt2.Columns.Add("EpisodeCde", typeof(int));
            dt2.Columns.Add("SeriesCde", typeof(int)).DefaultValue = "1";
            dt2.Columns.Add("versionCde", typeof(int)).AutoIncrement = true;

            
            dt2.Rows.Clear();
            DataRow row1 = dt2.Rows.Add();
            dt2.Rows.Add("1","1", "23");
            dt2.Rows.Add("1","0", "654");
            dt2.Rows.Add("1","1", "456");
            dt2.Rows.Add("0","0", "453");
            dt2.Rows.Add("0","1", "453");
            dt2.Rows.Add("0","0", "423");

            ds.Relations.Add(dt.Columns[0], dt1.Columns[2]);


            DataColumn[] parentColumns = new DataColumn[] {dt1.Columns["SeriesCde"],dt1.Columns["EpisodeCde"]};
            DataColumn[] childVersionColumns = new DataColumn[] {
	dt2.Columns["SeriesCde"],
	dt2.Columns["EpisodeCde"]
};
            DataRelation relEpisodeVersion = new DataRelation("VersionTable", parentColumns, childVersionColumns, false);
            ds.Relations.Add(relEpisodeVersion);


            ultraGrid1.DataSource = ds;


        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (e.Row.Band.Index == 0)
            {
                e.Row.Cells["UnboundColumn1"].Value = CalculateValue();
                //e.Row.Cells["UnboundColumn2"].Value = CalculateValue();

            }

            if (e.Row.Band.Index == 1)
            {
               // e.Row.Cells["UnboundColumn2"].Value = CalculateValue();
            }
        }

        private object CalculateValue()
        {
            Random rnd = new Random();
            Thread.Sleep(10);
            return string.Format("My Text {0}",rnd.Next(0, 1000000));;
        }
    }
}
